Index: sasmodels/models/core_shell_cylinder.c
===================================================================
--- sasmodels/models/core_shell_cylinder.c	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
+++ sasmodels/models/core_shell_cylinder.c	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -0,0 +1,92 @@
+real form_volume(real radius, real thickness, real length);
+real Iq(real q, real core_sld, real shell_sld, real solvent_sld,
+    real radius, real thickness, real length);
+real Iqxy(real qx, real qy, real core_sld, real shell_sld, real solvent_sld,
+    real radius, real thickness, real length, real theta, real phi);
+
+// twovd = 2 * volume * delta_rho
+// besarg = q * R * sin(alpha)
+// siarg = q * L/2 * cos(alpha)
+real _cyl(real twovd, real besarg, real siarg);
+real _cyl(real twovd, real besarg, real siarg)
+{
+    const real bj = (besarg == REAL(0.0) ? REAL(0.5) : J1(besarg)/besarg);
+    const real si = (siarg == REAL(0.0) ? REAL(1.0) : sin(siarg)/siarg);
+    return twovd*si*bj;
+}
+
+real form_volume(real radius, real thickness, real length)
+{
+    return M_PI*(radius+thickness)*(radius+thickness)*(length+2*thickness);
+}
+
+real Iq(real q,
+    real core_sld,
+    real shell_sld,
+    real solvent_sld,
+    real radius,
+    real thickness,
+    real length)
+{
+    // precalculate constants
+    const real core_qr = q*radius;
+    const real core_qh = q*REAL(0.5)*length;
+    const real core_twovd = REAL(2.0) * form_volume(radius,0,length)
+                            * (core_sld-shell_sld);
+    const real shell_qr = q*(radius + thickness);
+    const real shell_qh = q*(REAL(0.5)*length + thickness);
+    const real shell_twovd = REAL(2.0) * form_volume(radius,thickness,length)
+                             * (shell_sld-solvent_sld);
+    real total = REAL(0.0);
+    // real lower=0, upper=M_PI_2;
+    for (int i=0; i<76 ;i++) {
+        // translate a point in [-1,1] to a point in [lower,upper]
+        //const real alpha = ( Gauss76Z[i]*(upper-lower) + upper + lower )/2.0;
+        real sn, cn;
+        const real alpha = REAL(0.5)*(Gauss76Z[i]*M_PI_2 + M_PI_2);
+        SINCOS(alpha, sn, cn);
+        const real fq = _cyl(core_twovd, core_qr*sn, core_qh*cn)
+            + _cyl(shell_twovd, shell_qr*sn, shell_qh*cn);
+        total += Gauss76Wt[i] * fq * fq * sn;
+    }
+    // translate dx in [-1,1] to dx in [lower,upper]
+    //const real form = (upper-lower)/2.0*total;
+    return REAL(1.0e-4) * total * M_PI_4;
+}
+
+
+real Iqxy(real qx, real qy,
+    real core_sld,
+    real shell_sld,
+    real solvent_sld,
+    real radius,
+    real thickness,
+    real length,
+    real theta,
+    real phi)
+{
+    real sn, cn; // slots to hold sincos function output
+
+    // Compute angle alpha between q and the cylinder axis
+    SINCOS(theta*M_PI_180, sn, cn);
+    // # The following correction factor exists in sasview, but it can't be
+    // # right, so we are leaving it out for now.
+    // const real correction = fabs(cn)*M_PI_2;
+    const real q = sqrt(qx*qx+qy*qy);
+    const real cos_val = cn*cos(phi*M_PI_180)*(qx/q) + sn*(qy/q);
+    const real alpha = acos(cos_val);
+
+    const real core_qr = q*radius;
+    const real core_qh = q*REAL(0.5)*length;
+    const real core_twovd = REAL(2.0) * form_volume(radius,0,length)
+                            * (core_sld-shell_sld);
+    const real shell_qr = q*(radius + thickness);
+    const real shell_qh = q*(REAL(0.5)*length + thickness);
+    const real shell_twovd = REAL(2.0) * form_volume(radius,thickness,length)
+                             * (shell_sld-solvent_sld);
+
+    SINCOS(alpha, sn, cn);
+    const real fq = _cyl(core_twovd, core_qr*sn, core_qh*cn)
+        + _cyl(shell_twovd, shell_qr*sn, shell_qh*cn);
+    return REAL(1.0e-4) * fq * fq;
+}
Index: sasmodels/models/core_shell_cylinder.py
===================================================================
--- sasmodels/models/core_shell_cylinder.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
+++ sasmodels/models/core_shell_cylinder.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -0,0 +1,164 @@
+# core shell cylinder model
+# Note: model title and parameter table are inserted automatically
+r"""
+The form factor is normalized by the particle volume.
+
+Definition
+----------
+
+The output of the 2D scattering intensity function for oriented core-shell
+cylinders is given by (Kline, 2006)
+
+.. math::
+
+    P(q,\alpha) = \frac{\text{scale}}{V_s} f^2(q) + \text{background}
+
+where
+
+.. math::
+
+    f(q) = (\rho_c - \rho_s) V_c \
+           \frac{\sin( Q L/2 \cos \alpha)}{Q L/2 \cos \alpha} \
+           \frac{2 J_1 (Q R \sin \alpha)}{Q R \sin \alpha}
+           + (\rho_s - \rho_\text{solv}) V_s \
+           \frac{\sin( Q (L/2+T) \cos \alpha)}{Q (L/2+T) \cos \alpha}
+           \frac{2 J_1 (Q (R+T) \sin \alpha)}{Q (R+T) \sin \alpha}
+
+and
+
+.. math::
+
+    V_s = \pi (R + T)^2 \dot (L + 2T)
+
+
+and $\alpha$ is the angle between the axis of the cylinder and $\vec q$,
+$V_s$ is the volume of the outer shell (i.e. the total volume, including
+the shell), $V_c$ is the volume of the core, $L$ is the length of the core,
+$R$ is the radius of the core, $T$ is the thickness of the shell, $\rho_c$
+is the scattering length density of the core, $\rho_s$ is the scattering
+length density of the shell, $\rho_\text{solv}$ is the scattering length
+density of the solvent, and *background* is the background level.  The outer
+radius of the shell is given by $R+T$ and the total length of the outer
+shell is given by $L+2T$. $J1$ is the first order Bessel function.
+
+.. figure:: img/image069.JPG
+
+    Core shell cylinder schematic.
+
+To provide easy access to the orientation of the core-shell cylinder, we
+define the axis of the cylinder using two angles $\theta$ and $\phi$. As
+for the case of the cylinder, those angles are defined in
+Figure :num:`figure #cylinder-orientation`.
+
+NB: The 2nd virial coefficient of the cylinder is calculated based on
+the radius and 2 length values, and used as the effective radius for
+$S(Q)$ when $P(Q) \dot S(Q)$ is applied.
+
+The $\theta$ and $\phi$ parameters are not used for the 1D output. Our
+implementation of the scattering kernel and the 1D scattering intensity
+use the c-library from NIST.
+
+Validation
+----------
+
+Validation of our code was done by comparing the output of the 1D model to
+the output of the software provided by the NIST (Kline, 2006).
+Figure :num:`figure #core-shell-cylinder-comparison-1d` shows a comparison
+of the 1D output of our model and the output of the NIST software.
+
+.. _core-shell-cylinder-comparison-1d:
+
+.. figure:: img/image070.JPG
+
+    Comparison of the SasView scattering intensity for a core-shell cylinder
+    with the output of the NIST SANS analysis software. The parameters were
+    set to: *scale=1.0 |Ang|*, *radius=20 |Ang|*, *thickness=10 |Ang|*,
+    *length=400 |Ang|*, *core_sld=1e-6 |Ang^-2|*, *shell_sld=4e-6 |Ang^-2|*,
+    *solvent_sld=1e-6 |Ang^-2|*, and *background=0.01 |cm^-1|*.
+
+Averaging over a distribution of orientation is done by evaluating the
+equation above. Since we have no other software to compare the
+implementation of the intensity for fully oriented cylinders, we can
+compare the result of averaging our 2D output using a uniform
+distribution $p(\theta,\phi)* = 1.0$.
+Figure :num:`figure #core-shell-cylinder-comparison-2d` shows the result
+of such a cross-check.
+
+.. _core-shell-cylinder-comparison-2d:
+
+.. figure:: img/image071.JPG
+
+    Comparison of the intensity for uniformly distributed core-shell
+    cylinders calculated from our 2D model and the intensity from the
+    NIST SANS analysis software. The parameters used were: *scale*=1.0*,
+    *radius=20 |Ang|*, *thickness=10 |Ang|*, *length*=400 |Ang|*,
+    *core_sld=1e-6 |Ang^-2|*, *shell_sld=4e-6 |Ang^-2|*,
+    *solvent_sld=1e-6 |Ang^-2|*, and *background=0.0 |cm^-1|*.
+
+2013/11/26 - Description reviewed by Heenan, R.
+"""
+
+from numpy import pi, inf
+
+name = "cylinder"
+title = "Right circular cylinder with a core-shell scattering length density profile."
+description = """
+P(q,alpha)= scale/Vs*f(q)^(2) + background,
+      where: f(q)= 2(core_sld - solvant_sld)
+		* Vc*sin[qLcos(alpha/2)]
+		/[qLcos(alpha/2)]*J1(qRsin(alpha))
+		/[qRsin(alpha)]+2(shell_sld-solvent_sld)
+		*Vs*sin[q(L+T)cos(alpha/2)][[q(L+T)
+		*cos(alpha/2)]*J1(q(R+T)sin(alpha))
+		/q(R+T)sin(alpha)]
+
+	alpha:is the angle between the axis of
+		the cylinder and the q-vector
+	Vs: the volume of the outer shell
+	Vc: the volume of the core
+	L: the length of the core
+    	shell_sld: the scattering length density of the shell
+	solvent_sld: the scattering length density of the solvent
+	background: the background
+	T: the thickness
+    	R+T: is the outer radius
+ 	L+2T: The total length of the outershell
+	J1: the first order Bessel function
+ 	theta: axis_theta of the cylinder
+ 	phi: the axis_phi of the cylinder
+"""
+
+parameters = [
+#   [ "name", "units", default, [lower, upper], "type",
+#     "description" ],
+    [ "core_sld", "1e-6/Ang^2", 4, [-inf,inf], "",
+      "Cylinder core scattering length density" ],
+    [ "shell_sld", "1e-6/Ang^2", 4, [-inf,inf], "",
+      "Cylinder shell scattering length density" ],
+    [ "solvent_sld", "1e-6/Ang^2", 1, [-inf,inf], "",
+      "Solvent scattering length density" ],
+    [ "radius", "Ang",  20, [0, inf], "volume",
+      "Cylinder core radius" ],
+    [ "thickness", "Ang",  20, [0, inf], "volume",
+      "Cylinder shell thickness" ],
+    [ "length", "Ang",  400, [0, inf], "volume",
+      "Cylinder length" ],
+    [ "theta", "degrees", 60, [-inf, inf], "orientation",
+      "In plane angle" ],
+    [ "phi", "degrees", 60, [-inf, inf], "orientation",
+      "Out of plane angle" ],
+    ]
+
+source = [ "lib/J1.c", "lib/gauss76.c", "core_shell_cylinder.c"]
+
+def ER(radius, thickness, length):
+    radius = radius + thickness
+    length = length + 2*thickness
+    ddd = 0.75*radius*(2*radius*length + (length+radius)*(length+pi*radius))
+    return 0.5 * (ddd)**(1./3.)
+
+def VR(radius, thickness, length):
+    whole = pi * (radius+thickness)**2 * (length+2*thickness)
+    core = pi * radius**2 * length
+    return whole, whole-core
+
Index: sasmodels/models/cylinder.c
===================================================================
--- sasmodels/models/cylinder.c	(revision ff7119b4ad066090cdffae80706883cef3d80399)
+++ sasmodels/models/cylinder.c	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -1,5 +1,17 @@
 real form_volume(real radius, real length);
 real Iq(real q, real sld, real solvent_sld, real radius, real length);
-real Iqxy(real qx, real qy, real sld, real solvent_sld, real radius, real length, real theta, real phi);
+real Iqxy(real qx, real qy, real sld, real solvent_sld,
+    real radius, real length, real theta, real phi);
+
+// twovd = 2 * volume * delta_rho
+// besarg = q * R * sin(alpha)
+// siarg = q * L/2 * cos(alpha)
+real _cyl(real twovd, real besarg, real siarg);
+real _cyl(real twovd, real besarg, real siarg)
+{
+    const real bj = (besarg == REAL(0.0) ? REAL(0.5) : J1(besarg)/besarg);
+    const real si = (siarg == REAL(0.0) ? REAL(1.0) : sin(siarg)/siarg);
+    return twovd*si*bj;
+}
 
 real form_volume(real radius, real length)
@@ -14,22 +26,21 @@
     real length)
 {
-    const real halflength = REAL(0.5)*length;
-    real summ = REAL(0.0);
+    const real qr = q*radius;
+    const real qh = q*REAL(0.5)*length;
+    const real twovd = REAL(2.0)*(sld-solvent_sld)*form_volume(radius, length);
+    real total = REAL(0.0);
     // real lower=0, upper=M_PI_2;
     for (int i=0; i<76 ;i++) {
         // translate a point in [-1,1] to a point in [lower,upper]
-        //const real zi = ( Gauss76Z[i]*(upper-lower) + upper + lower )/2.0;
-        const real zi = REAL(0.5)*(Gauss76Z[i]*M_PI_2 + M_PI_2);
-        summ += Gauss76Wt[i] * CylKernel(q, radius, halflength, zi);
+        //const real alpha = ( Gauss76Z[i]*(upper-lower) + upper + lower )/2.0;
+        const real alpha = REAL(0.5)*(Gauss76Z[i]*M_PI_2 + M_PI_2);
+        real sn, cn;
+        SINCOS(alpha, sn, cn);
+        const real fq = _cyl(twovd, qr*sn, qh*cn);
+        total += Gauss76Wt[i] * fq * fq * sn;
     }
     // translate dx in [-1,1] to dx in [lower,upper]
-    //const real form = (upper-lower)/2.0*summ;
-    const real form = summ * M_PI_4;
-
-    // Multiply by contrast^2, normalize by cylinder volume and convert to cm-1
-    // NOTE that for this (Fournet) definition of the integral, one must MULTIPLY by Vcyl
-    // The additional volume factor is for polydisperse volume normalization.
-    const real s = (sld - solvent_sld) * form_volume(radius, length);
-    return REAL(1.0e-4) * form * s * s;
+    //const real form = (upper-lower)/2.0*total;
+    return REAL(1.0e-4) * total * M_PI_4;
 }
 
@@ -43,4 +54,7 @@
     real phi)
 {
+    // TODO: check that radius<0 and length<0 give zero scattering.
+    // This should be the case since the polydispersity weight vector should
+    // be zero length, and this function never called.
     real sn, cn; // slots to hold sincos function output
 
@@ -54,19 +68,7 @@
     const real alpha = acos(cos_val);
 
-    // The following is CylKernel() / sin(alpha), but we are doing it in place
-    // to avoid sin(alpha)/sin(alpha) for alpha = 0.  It is also a teensy bit
-    // faster since we don't mulitply and divide sin(alpha).
+    const real twovd = REAL(2.0)*(sld-solvent_sld)*form_volume(radius, length);
     SINCOS(alpha, sn, cn);
-    const real besarg = q*radius*sn;
-    const real siarg = REAL(0.5)*q*length*cn;
-    // lim_{x->0} J1(x)/x = 1/2,   lim_{x->0} sin(x)/x = 1
-    const real bj = (besarg == REAL(0.0) ? REAL(0.5) : J1(besarg)/besarg);
-    const real si = (siarg == REAL(0.0) ? REAL(1.0) : sin(siarg)/siarg);
-    const real form = REAL(4.0)*bj*bj*si*si;
-
-    // Multiply by contrast^2, normalize by cylinder volume and convert to cm-1
-    // NOTE that for this (Fournet) definition of the integral, one must MULTIPLY by Vcyl
-    // The additional volume factor is for polydisperse volume normalization.
-    const real s = (sld - solvent_sld) * form_volume(radius, length);
-    return REAL(1.0e-4) * form * s * s; // * correction;
+    const real fq = _cyl(twovd, q*radius*sn, q*REAL(0.5)*length*cn);
+    return REAL(1.0e-4) * fq * fq; // * correction;
 }
Index: sasmodels/models/cylinder.py
===================================================================
--- sasmodels/models/cylinder.py	(revision a7684e5745716d713f91b1ebc1027632a3ff9d36)
+++ sasmodels/models/cylinder.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -1,2 +1,3 @@
+# cylinder model
 # Note: model title and parameter table are inserted automatically
 r"""
@@ -31,7 +32,7 @@
 To provide easy access to the orientation of the cylinder, we define the
 axis of the cylinder using two angles $\theta$ and $\phi$. Those angles
-are defined in Figure :num:`figure #CylinderModel-orientation`.
+are defined in Figure :num:`figure #cylinder-orientation`.
 
-.. _CylinderModel-orientation:
+.. _cylinder-orientation:
 
 .. figure:: img/image061.JPG   (should be img/cylinder-1.jpg, or img/cylinder-orientation.jpg)
@@ -64,8 +65,8 @@
 Validation of our code was done by comparing the output of the 1D model
 to the output of the software provided by the NIST (Kline, 2006).
-Figure :num:`figure #CylinderModel-compare` shows a comparison of
+Figure :num:`figure #cylinder-compare` shows a comparison of
 the 1D output of our model and the output of the NIST software.
 
-.. _CylinderModel-compare:
+.. _cylinder-compare:
 
 .. figure:: img/image065.JPG
@@ -91,8 +92,8 @@
 the intensity for fully oriented cylinders, we can compare the result of
 averaging our 2D output using a uniform distribution $p(\theta, \phi) = 1.0$.
-Figure :num:`figure #CylinderModel-crosscheck` shows the result of
+Figure :num:`figure #cylinder-crosscheck` shows the result of
 such a cross-check.
 
-.. _CylinderModel-crosscheck:
+.. _cylinder-crosscheck:
 
 .. figure:: img/image066.JPG
@@ -111,5 +112,5 @@
 title = "Right circular cylinder with uniform scattering length density."
 description = """
-     f(q)= 2*(sldCyl - sldSolv)*V*sin(qLcos(alpha/2))
+     P(q)= 2*(sld - solvent_sld)*V*sin(qLcos(alpha/2))
             /[qLcos(alpha/2)]*J1(qRsin(alpha/2))/[qRsin(alpha)]
 
@@ -119,10 +120,10 @@
             L: Length of the cylinder
             J1: The bessel function
-            alpha: angle betweenthe axis of the
+            alpha: angle between the axis of the
             cylinder and the q-vector for 1D
             :the ouput is P(q)=scale/V*integral
             from pi/2 to zero of...
-            f(q)^(2)*sin(alpha)*dalpha+ bkg
-    """
+            f(q)^(2)*sin(alpha)*dalpha + background
+"""
 
 parameters = [
@@ -143,5 +144,5 @@
     ]
 
-source = [ "lib/J1.c", "lib/gauss76.c", "lib/cylkernel.c", "cylinder.c"]
+source = [ "lib/J1.c", "lib/gauss76.c", "cylinder.c" ]
 
 def ER(radius, length):
Index: sasmodels/models/cylinder_clone.c
===================================================================
--- sasmodels/models/cylinder_clone.c	(revision ff7119b4ad066090cdffae80706883cef3d80399)
+++ sasmodels/models/cylinder_clone.c	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -2,4 +2,16 @@
 real Iq(real q, real sld, real solvent_sld, real radius, real length);
 real Iqxy(real qx, real qy, real sld, real solvent_sld, real radius, real length, real theta, real phi);
+
+
+// twovd = 2 * volume * delta_rho
+// besarg = q * R * sin(alpha)
+// siarg = q * L/2 * cos(alpha)
+real _cyl(real twovd, real besarg, real siarg, real alpha);
+real _cyl(real twovd, real besarg, real siarg, real alpha)
+{
+    const real bj = (besarg == REAL(0.0) ? REAL(0.5) : J1(besarg)/besarg);
+    const real si = (siarg == REAL(0.0) ? REAL(1.0) : sin(siarg)/siarg);
+    return twovd*si*bj;
+}
 
 real form_volume(real radius, real length)
@@ -7,5 +19,4 @@
     return M_PI*radius*radius*length;
 }
-
 real Iq(real q,
     real sldCyl,
@@ -14,19 +25,21 @@
     real length)
 {
-    const real h = REAL(0.5)*length;
-    real summ = REAL(0.0);
+    const real qr = q*radius;
+    const real qh = q*REAL(0.5)*length;
+    const real twovd = REAL(2.0)*(sldCyl-sldSolv)*form_volume(radius, length);
+    real total = REAL(0.0);
+    // real lower=0, upper=M_PI_2;
     for (int i=0; i<76 ;i++) {
-        //const real zi = ( Gauss76Z[i]*(uplim-lolim) + uplim + lolim )/2.0;
-        const real zi = REAL(0.5)*(Gauss76Z[i]*M_PI_2 + M_PI_2);
-        summ += Gauss76Wt[i] * CylKernel(q, radius, h, zi);
+        // translate a point in [-1,1] to a point in [lower,upper]
+        //const real alpha = ( Gauss76Z[i]*(upper-lower) + upper + lower )/2.0;
+        const real alpha = REAL(0.5)*(Gauss76Z[i]*M_PI_2 + M_PI_2);
+        real sn, cn;
+        SINCOS(alpha, sn, cn);
+        const real fq = _cyl(twovd, qr*sn, qh*cn, alpha);
+        total += Gauss76Wt[i] * fq * fq * sn;
     }
-    //const real form = (uplim-lolim)/2.0*summ;
-    const real form = summ * M_PI_4;
-
-    // Multiply by contrast^2, normalize by cylinder volume and convert to cm-1
-    // NOTE that for this (Fournet) definition of the integral, one must MULTIPLY by Vcyl
-    // The additional volume factor is for polydisperse volume normalization.
-    const real s = (sldCyl - sldSolv) * form_volume(radius, length);
-    return REAL(1.0e8) * form * s * s;
+    // translate dx in [-1,1] to dx in [lower,upper]
+    //const real form = (upper-lower)/2.0*total;
+    return REAL(1.0e8) * total * M_PI_4;
 }
 
@@ -50,19 +63,9 @@
     const real alpha = acos(cos_val);
 
-    // The following is CylKernel() / sin(alpha), but we are doing it in place
-    // to avoid sin(alpha)/sin(alpha) for alpha = 0.  It is also a teensy bit
-    // faster since we don't mulitply and divide sin(alpha).
+    const real qr = q*radius;
+    const real qh = q*REAL(0.5)*length;
+    const real twovd = REAL(2.0)*(sldCyl-sldSolv)*form_volume(radius, length);
     SINCOS(alpha, sn, cn);
-    const real besarg = q*radius*sn;
-    const real siarg = REAL(0.5)*q*length*cn;
-    // lim_{x->0} J1(x)/x = 1/2,   lim_{x->0} sin(x)/x = 1
-    const real bj = (besarg == REAL(0.0) ? REAL(0.5) : J1(besarg)/besarg);
-    const real si = (siarg == REAL(0.0) ? REAL(1.0) : sin(siarg)/siarg);
-    const real form = REAL(4.0)*bj*bj*si*si;
-
-    // Multiply by contrast^2, normalize by cylinder volume and convert to cm-1
-    // NOTE that for this (Fournet) definition of the integral, one must MULTIPLY by Vcyl
-    // The additional volume factor is for polydisperse volume normalization.
-    const real s = (sldCyl - sldSolv) * form_volume(radius, length);
-    return REAL(1.0e8) * form * s * s * spherical_integration;
+    const real fq = _cyl(twovd, qr*sn, qh*cn, alpha);
+    return REAL(1.0e8) * fq * fq * spherical_integration;
 }
Index: sasmodels/models/cylinder_clone.py
===================================================================
--- sasmodels/models/cylinder_clone.py	(revision a7684e5745716d713f91b1ebc1027632a3ff9d36)
+++ sasmodels/models/cylinder_clone.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -150,5 +150,5 @@
       "Out of plane angle" ],
     ]
-source = [ "lib/J1.c", "lib/gauss76.c", "lib/cylkernel.c", "cylinder_clone.c"]
+source = [ "lib/J1.c", "lib/gauss76.c", "cylinder_clone.c" ]
 
 def ER(radius, length):
Index: sasmodels/models/cylinder_onefile.py
===================================================================
--- sasmodels/models/cylinder_onefile.py	(revision a7684e5745716d713f91b1ebc1027632a3ff9d36)
+++ sasmodels/models/cylinder_onefile.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -154,9 +154,9 @@
 source = [ "lib/J1.c", "lib/gauss76.c", "lib/cylkernel.c" ]
 
-c_form_volume = """
+form_volume = """
     return M_PI*radius*radius*length;
-"""
-
-c_Iq = """
+    """
+
+Iq = """
     const real h = REAL(0.5)*length;
     real summ = REAL(0.0);
@@ -174,7 +174,7 @@
     const real s = (sld - solvent_sld) * form_volume(radius, length);
     return REAL(1.0e-4) * form * s * s;
-"""
-
-c_Iqxy = """
+    """
+
+Iqxy = """
     real sn, cn; // slots to hold sincos function output
 
@@ -204,5 +204,5 @@
     const real s = (sld - solvent_sld) * form_volume(radius, length);
     return REAL(1.0e-4) * form * s * s; // * correction;
-"""
+    """
 
 def ER(radius, length):
Index: sasmodels/models/ellipsoid.c
===================================================================
--- sasmodels/models/ellipsoid.c	(revision ce27e213b076822e24ff35e97da5c4dd53eb45b0)
+++ sasmodels/models/ellipsoid.c	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -1,48 +1,22 @@
-/* PARAMETERS
+real form_volume(real rpolar, real requatorial);
+real Iq(real q, real sld, real solvent_sld, real rpolar, real requatorial);
+real Iqxy(real qx, real qy, real sld, real solvent_sld,
+    real rpolar, real requatorial, real theta, real phi);
+
+real _ellipsoid_kernel(real q, real rpolar, real requatorial, real cos_alpha);
+real _ellipsoid_kernel(real q, real rpolar, real requatorial, real cos_alpha)
 {
-name: "ellipsoid",
-title: "Ellipsoid with uniform scattering length density",
-include: [ "lib/gauss76.c" ],
-parameters: [
-   // [ "name", "units", default, [lower, upper], "type", "description" ],
-   [ "sld", "1e-6/Ang^2", 4, [-Infinity,Infinity], "",
-     "Cylinder scattering length density" ],
-   [ "solvent_sld", "1e-6/Ang^2", 1, [-Infinity,Infinity], "",
-     "Solvent scattering length density" ],
-   [ "a", "Ang",  20, [0, Infinity], "volume",
-     "Cylinder radius" ],
-   [ "b", "Ang",  20, [0, Infinity], "volume",
-     "Cylinder length" ],
-   [ "theta", "degrees", 60, [-Infinity, Infinity], "orientation",
-     "In plane angle" ],
-   [ "phi", "degrees", 60, [-Infinity, Infinity], "orientation",
-     "Out of plane angle" ],
-],
-}
-PARAMETERS END
-
-DOCUMENTATION
-.. _EllipseModel:
-
-DOCUMENTATION END
-*/
-
-real form_volume(real a, real b);
-real Iq(real qx, real qy, real sld, real solvent_sld, real a, real b);
-real Iqxy(real qx, real qy, real sld, real solvent_sld, real a, real b, real theta, real phi);
-
-real form_volume(real a, real b)
-{
-    return REAL(1.333333333333333)*M_PI_2*a*b*b;
+    real sn, cn;
+    real ratio = rpolar/requatorial;
+    const real u = q*requatorial*sqrt(REAL(1.0)
+                   + cos_alpha*cos_alpha*(ratio*ratio - REAL(1.0)));
+    SINCOS(u, sn, cn);
+    const real f = ( u==REAL(0.0) ? REAL(1.0) : REAL(3.0)*(sn-u*cn)/(u*u*u) );
+    return f*f;
 }
 
-real ellipsoid_kernel(double q, double b, double a, double dum)
+real form_volume(real rpolar, real requatorial)
 {
-    real sn, cn;
-    const real nu = a/b;
-    const real arg = q * b * sqrt(REAL(1.0)+(dum*dum*(nu*nu--REAL(1.0))));
-    SINCOS(arg, sn, cn);
-    const real f = (arg==REAL(0.0) ? REAL(1.0) : REAL(3.0)*(sn-arg*cn)/(arg*arg*arg);
-    return f*f;
+    return REAL(1.333333333333333)*M_PI*rpolar*requatorial*requatorial;
 }
 
@@ -50,16 +24,18 @@
     real sld,
     real solvent_sld,
-    real a,
-    real b)
+    real rpolar,
+    real requatorial)
 {
-    real summ = REAL(0.0);
+    //const real lower = REAL(0.0);
+    //const real upper = REAL(1.0);
+    real total = REAL(0.0);
     for (int i=0;i<76;i++) {
-        //const real zi = ( Gauss76Z[i]*(uplim-lolim) + uplim + lolim )/2.0;
-        zi = ( Gauss76Z[i] + REAL(1.0))/REAL(2.0);
-        summ += Gauss76Wt[i] * ellipsoid_kernel(q, b, a, zi);
+        //const real cos_alpha = (Gauss76Z[i]*(upper-lower) + upper + lower)/2;
+        const real cos_alpha = REAL(0.5)*(Gauss76Z[i] + REAL(1.0));
+        total += Gauss76Wt[i] * _ellipsoid_kernel(q, rpolar, requatorial, cos_alpha);
     }
-    //const real form = (uplim-lolim)/2.0*summ;
-    const real form = REAL(0.5)*summ
-    const real s = (sld - sld_solvent) * form_volume(a, b);
+    //const real form = (upper-lower)/2*total;
+    const real form = REAL(0.5)*total;
+    const real s = (sld - solvent_sld) * form_volume(rpolar, requatorial);
     return REAL(1.0e-4) * form * s * s;
 }
@@ -68,6 +44,6 @@
     real sld,
     real solvent_sld,
-    real a,
-    real b,
+    real rpolar,
+    real requatorial,
     real theta,
     real phi)
@@ -77,7 +53,7 @@
     const real q = sqrt(qx*qx + qy*qy);
     SINCOS(theta*M_PI_180, sn, cn);
-    const real cos_val = cn*cos(phi*M_PI_180)*(qx/q) + sn*(qy/q);
-    const real form = ellipsoid_kernel(q, b, a, cos_val);
-    const real s = (sld - solvent_sld) * form_volume(a, b);
+    const real cos_alpha = cn*cos(phi*M_PI_180)*(qx/q) + sn*(qy/q);
+    const real form = _ellipsoid_kernel(q, rpolar, requatorial, cos_alpha);
+    const real s = (sld - solvent_sld) * form_volume(rpolar, requatorial);
 
     return REAL(1.0e-4) * form * s * s;
